# sammler
> Let's get some insights. And it's fine to be a data junkie.

- [Why](#why)
- [MVP](#mvp)
- [Guiding Principles](#guiding-principles)
- [Technology Choices](#technology-choices)
- [FAQ](#faq)
- [Contributing](#contributing)
- [Author](#author)
- [License](#license)

_(TOC generated by [verb](https://github.com/verbose/verb) using [markdown-toc](https://github.com/jonschlinkert/markdown-toc))_

## Why
<!-- Why -->

_sammler_ is the attempt to bring business life, social activities and IoT together.

I am fully adopting cloud computing as consumer and producer, but I hate it, that I don't have all the data available at a fingertip  - just to be able to analyze them.  
Furthermore I am fully adopting IoT, collecting already more than 1GB each week.

So I need a solution to constantly collect and analyze all the data, their correlation, just to get interesting insights. Otherwise data is useless.  

The ultimate goal of this project:

- Analyze activities in the three different areas (business life, social activities, IoT).
- Create a pluggable system, so that it can be easily extended.
- Be able to have access and analyze the full history in all areas.

### But, wait ...  

There is also another reason for _sammler_:  
As I am constantly testing new architectural and technical approaches, I just need a playground to test and validate technologies in general and in particular cloud related solutions.
The entire setup of _sammler_ is also my reference implementation of a microservices based architecture, using some of the cutting edge solutions out there.

Finally, don't take the entire project [too seriously](https://circleci.com/blog/its-the-future/).

## MVP
You might be interested in the first definition of the [MVP](docs/mvp.md) of _sammler_.

## Guiding Principles
<!-- Principles -->
- Everything is Open Sourced.
- Follow a Readme Driven Development.
    - Publish everything: my progress, failure, thoughts, decisions.  
    (Will be fun in a year from now to especially read all the silly decisions ;-))
- Use as much existing solutions as possible, focus on assembling, rather than writing new code.
- All activities should be continuously tested and deployed to the cloud.
- The entire solution needs to multi-tenant enabled.
- Embrace the concept of microservices.
- Don't introduce any dependencies on cloud providers such as Amazon, Azure, etc.
- Automate, automate, automate.

## Technology Choices
<!-- Technology Choices -->
Some opinionated assumptions and technology choices have been made. But this might change over time.

- Programming languages: JavaScript/TypeScript, GoLang
- Storage: MongoDB, PostgreSql
- UI framework: Angular
- Containerization: Docker

All other decisions will be documented over time.

## FAQ
### What does _sammler_ mean?

_sammler_ is the german word for collector, gatherer, assembler or collecting agent.

### How is the name written?

_sammler_, not Sammler. 

### What's _s5r_ ?

_s5r_ is just the abbreviation for sammler, just being lazy and because it looks cool and unique ;-)

## Contributing
Primarily I do - especially at the beginning and in the next months - not expect any contributions, and that's fine.  
I might pretty slowly progress on this project, as this is just a private project, only working on it in my free time.

But stop: You might have similar requirements and interest, so please do not hesitate to [drop me a line](https://github.com/sammler/sammler/issues) and add your thoughts.  
Even if you do not want to actively participate, I am very interested in listening to your opinion and your related requirements.  

Certainly any contribution is highly appreciated and will for sure encourage me to even work harder on this project.

Let's see, keep fingers crossed, I am curious, too, where this project finally ends up.

## Author
**Stefan Walther**
* [qliksite.io](http://qliksite.io)
* [twitter/waltherstefan](http://twitter.com/waltherstefan)
* [github.com/stefanwalther](http://github.com/stefanwalther)

## License
Released under the MIT license.

***

_This file was generated by [verb-generate-readme](https://github.com/verbose/verb-generate-readme), v0.2.0, on January 07, 2017._

